import glamorous from 'glamorous';
import { NotieLevel } from './actions';
var colors = (_a = {},
    _a[NotieLevel.SUCCESS] = '#13ce66',
    _a[NotieLevel.ERROR] = '#ff4949',
    _a[NotieLevel.INFO] = '#20a0ff',
    _a[NotieLevel.WARN] = '#f5be4b',
    _a[NotieLevel.CONFIRM] = '#20a0ff',
    _a[NotieLevel.FORCE] = '#20a0ff',
    _a);
export var NotieContainer = glamorous('div')({
    position: 'fixed',
    width: '100%',
    textAlign: 'center',
    fontSize: '14px',
    color: '#fff',
    transition: 'transform 0.3s ease-in-out',
    margin: '0 auto',
    whiteSpace: 'nowrap',
    // overflow: 'hidden',
    textOverflow: 'ellipsis',
    left: 0
}, function (props) { return ({
    pointerEvents: props.active ? 'auto' : 'none',
    top: props.position === 'top' ? 0 : 'auto',
    bottom: props.position === 'bottom' ? 0 : 'auto',
    transform: props.active
        ? 'translate(0, 0)'
        : props.position === 'top' ? 'translate(0, -106%)' : 'translate(0, 106%)',
    backgroundColor: props.level in colors ? colors[props.level] : '#444'
}); });
NotieContainer.displayName = 'NotieContainer';
export var NotieOverlay = glamorous('div')({
    position: 'fixed',
    minHeight: '100vh',
    height: '100%',
    top: '0',
    left: '0',
    width: '100%',
    backgroundColor: 'rgba(255, 255, 255, 0.65)'
});
NotieOverlay.displayName = 'NotieOverlay';
export var NotieMessage = glamorous('div')({
    padding: '20px'
});
NotieMessage.displayName = 'NotieMessage';
export var NotieChoices = glamorous('div')({
    display: 'flex',
    width: '100%'
});
NotieChoices.displayName = 'NotieChoices';
export var NotieButton = glamorous('button')({
    padding: '20px',
    flexGrow: 1,
    border: 'none',
    textAlign: 'center',
    cursor: 'pointer'
}, function (props) { return ({
    backgroundColor: props.level in colors ? colors[props.level] : '#444'
}); });
NotieButton.displayName = 'NotieButton';
var _a;
