export var NotieLevel;
(function (NotieLevel) {
    NotieLevel["INFO"] = "INFO";
    NotieLevel["ERROR"] = "ERROR";
    NotieLevel["SUCCESS"] = "SUCCESS";
    NotieLevel["WARN"] = "WARN";
    NotieLevel["FORCE"] = "FORCE";
    NotieLevel["CONFIRM"] = "CONFIRM";
})(NotieLevel || (NotieLevel = {}));
export var NotieActions;
(function (NotieActions) {
    NotieActions["SHOW"] = "notie.show";
    NotieActions["HIDE"] = "notie.hide";
})(NotieActions || (NotieActions = {}));
export function dispatchGlobalEvent(eventName, opts, target = window) {
    // Compatibale with IE
    // @see http://stackoverflow.com/questions/26596123/internet-explorer-9-10-11-event-constructor-doesnt-work
    let event;
    if (typeof window.CustomEvent === 'function') {
        event = new window.CustomEvent(eventName, { detail: opts });
    }
    else {
        event = document.createEvent('CustomEvent');
        event.initCustomEvent(eventName, false, true, opts);
    }
    if (target) {
        target.dispatchEvent(event);
    }
}
export function alert(settings) {
    dispatchGlobalEvent(NotieActions.SHOW, settings);
}
export function success(message, ttl) {
    alert({ message, level: NotieLevel.SUCCESS, ttl });
}
export function error(message, ttl) {
    alert({ message, level: NotieLevel.ERROR, ttl });
}
export function warn(message, ttl) {
    alert({ message, level: NotieLevel.WARN, ttl });
}
export function info(message, ttl) {
    alert({ message, level: NotieLevel.INFO, ttl });
}
export function confirm(message, props) {
    return new Promise((resolve, reject) => {
        alert(Object.assign({}, props, {
            message,
            level: NotieLevel.CONFIRM,
            confirmResolve: resolve,
            confirmReject: reject
        }));
    });
}
export function force(message, props) {
    return new Promise((resolve, reject) => {
        alert(Object.assign({}, props, {
            message,
            level: NotieLevel.FORCE,
            confirmResolve: resolve,
            confirmReject: reject
        }));
    });
}
