export declare enum NotieLevel {
    INFO = "INFO",
    ERROR = "ERROR",
    SUCCESS = "SUCCESS",
    WARN = "WARN",
    FORCE = "FORCE",
    CONFIRM = "CONFIRM",
}
export declare enum NotieActions {
    SHOW = "notie.show",
    HIDE = "notie.hide",
}
export interface NotieSettings {
    message: string;
    level: NotieLevel;
    yesBtnText?: string;
    noBtnText?: string;
    ttl?: number;
}
export declare type NotieCallback = (...args: any[]) => void;
export interface NotieEventDetails extends NotieSettings {
    confirmResolve: NotieCallback;
    confirmReject: NotieCallback;
}
export declare function dispatchGlobalEvent(eventName: string, opts: any, target?: EventTarget): void;
export declare function alert(settings: NotieSettings): void;
export declare function success(message: string, ttl?: number): void;
export declare function error(message: string, ttl?: number): void;
export declare function warn(message: string, ttl?: number): void;
export declare function info(message: string, ttl?: number): void;
export declare function confirm(message: string, props?: Partial<NotieSettings>): Promise<{}>;
export declare function force(message: string, props?: Partial<NotieSettings>): Promise<{}>;
