"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NotieLevel;
(function (NotieLevel) {
    NotieLevel["INFO"] = "INFO";
    NotieLevel["ERROR"] = "ERROR";
    NotieLevel["SUCCESS"] = "SUCCESS";
    NotieLevel["WARN"] = "WARN";
    NotieLevel["FORCE"] = "FORCE";
    NotieLevel["CONFIRM"] = "CONFIRM";
})(NotieLevel = exports.NotieLevel || (exports.NotieLevel = {}));
var NotieActions;
(function (NotieActions) {
    NotieActions["SHOW"] = "notie.show";
    NotieActions["HIDE"] = "notie.hide";
})(NotieActions = exports.NotieActions || (exports.NotieActions = {}));
function dispatchGlobalEvent(eventName, opts, target) {
    if (target === void 0) { target = window; }
    // Compatibale with IE
    // @see http://stackoverflow.com/questions/26596123/internet-explorer-9-10-11-event-constructor-doesnt-work
    var event;
    if (typeof window.CustomEvent === 'function') {
        event = new window.CustomEvent(eventName, { detail: opts });
    }
    else {
        event = document.createEvent('CustomEvent');
        event.initCustomEvent(eventName, false, true, opts);
    }
    if (target) {
        target.dispatchEvent(event);
    }
}
exports.dispatchGlobalEvent = dispatchGlobalEvent;
function alert(settings) {
    dispatchGlobalEvent(NotieActions.SHOW, settings);
}
exports.alert = alert;
function success(message, ttl) {
    alert({ message: message, level: NotieLevel.SUCCESS, ttl: ttl });
}
exports.success = success;
function error(message, ttl) {
    alert({ message: message, level: NotieLevel.ERROR, ttl: ttl });
}
exports.error = error;
function warn(message, ttl) {
    alert({ message: message, level: NotieLevel.WARN, ttl: ttl });
}
exports.warn = warn;
function info(message, ttl) {
    alert({ message: message, level: NotieLevel.INFO, ttl: ttl });
}
exports.info = info;
function confirm(message, props) {
    return new Promise(function (resolve, reject) {
        alert(Object.assign({}, props, {
            message: message,
            level: NotieLevel.CONFIRM,
            confirmResolve: resolve,
            confirmReject: reject
        }));
    });
}
exports.confirm = confirm;
function force(message, props) {
    return new Promise(function (resolve, reject) {
        alert(Object.assign({}, props, {
            message: message,
            level: NotieLevel.FORCE,
            confirmResolve: resolve,
            confirmReject: reject
        }));
    });
}
exports.force = force;
