"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var glamorous_1 = require("glamorous");
var actions_1 = require("./actions");
var colors = (_a = {},
    _a[actions_1.NotieLevel.SUCCESS] = '#13ce66',
    _a[actions_1.NotieLevel.ERROR] = '#ff4949',
    _a[actions_1.NotieLevel.INFO] = '#20a0ff',
    _a[actions_1.NotieLevel.WARN] = '#f5be4b',
    _a[actions_1.NotieLevel.CONFIRM] = '#20a0ff',
    _a[actions_1.NotieLevel.FORCE] = '#20a0ff',
    _a);
exports.NotieContainer = glamorous_1.default('div')({
    position: 'fixed',
    width: '100%',
    textAlign: 'center',
    fontSize: '14px',
    color: '#fff',
    transition: 'transform 0.3s ease-in-out',
    margin: '0 auto',
    whiteSpace: 'nowrap',
    // overflow: 'hidden',
    textOverflow: 'ellipsis',
    left: 0
}, function (props) { return ({
    pointerEvents: props.active ? 'auto' : 'none',
    top: props.position === 'top' ? 0 : 'auto',
    bottom: props.position === 'bottom' ? 0 : 'auto',
    transform: props.active
        ? 'translate(0, 0)'
        : props.position === 'top' ? 'translate(0, -106%)' : 'translate(0, 106%)',
    backgroundColor: props.level in colors ? colors[props.level] : '#444'
}); });
exports.NotieContainer.displayName = 'NotieContainer';
exports.NotieOverlay = glamorous_1.default('div')({
    position: 'fixed',
    minHeight: '100vh',
    height: '100%',
    top: '0',
    left: '0',
    width: '100%',
    backgroundColor: 'rgba(255, 255, 255, 0.65)'
});
exports.NotieOverlay.displayName = 'NotieOverlay';
exports.NotieMessage = glamorous_1.default('div')({
    padding: '20px'
});
exports.NotieMessage.displayName = 'NotieMessage';
exports.NotieChoices = glamorous_1.default('div')({
    display: 'flex',
    width: '100%'
});
exports.NotieChoices.displayName = 'NotieChoices';
exports.NotieButton = glamorous_1.default('button')({
    padding: '20px',
    flexGrow: 1,
    border: 'none',
    textAlign: 'center',
    cursor: 'pointer'
}, function (props) { return ({
    backgroundColor: props.level in colors ? colors[props.level] : '#444'
}); });
exports.NotieButton.displayName = 'NotieButton';
var _a;
